let gridManager = null;
let coRowNum=0;
//页面控制标识
let control = {
    isInitiator: false,//是否为审核人
    isDistribute: false,//是否已分发
    isConfirm:false,//是否已确认
}

$(document).ready(function () {
    initializate()
    loadRejectReasonBox();
    bindEvent();
})


function initializate() {
   // UICtrl.setDisable("#businessUsageDiv")
    UICtrl.setDisable("#totalContentDiv");
    coRowNum= $("#busiLens").val();
    //$("#klart").val("023")
    //$("#classify").val("Z_YCL")
    //页面控制
    UICtrl.enable($("#businessUsage"));
    UICtrl.enable($("#matklName"));

    initbstmi($("#mtart").val());
    initKunnrName($("#mtart").val());
    //物品类型 控制存储的序列号参数
    $("#mtart").combox({onChange:function(data) {

        //物料类型是：服务，项目类别组：LEIS；其他NORM
         if (data.value == "ZSRV"){
            $("#mtposMara").val("LEIS");
             Public.tip("服务类物品不维护生产、存储管理、仓库管理视图");
             $("#businessUsageL").prop("checked",false);
             $("#businessUsageA").prop("checked",false);
             $("#businessUsageS").prop("checked",false);

             UICtrl.setElRequiredFlag("#lgortName",false);

             $("#businessUsageV").prop("checked",true);
             $("#businessUsageE").prop("checked",true);
             $("#businessUsageD").prop("checked",true);
             $("#businessUsageB").prop("checked",true);
             $('input[name="isAll"]').attr("checked",false);
         }else {
             $("#mtposMara").val("NORM");
             UICtrl.setElRequiredFlag("#lgortName",true);
         }
            bstmiChange(false);
         //物料类型是：半成品、辅料与包材、免费客供/外部来源物品、贸易商品、原材料、产成品。批次管理：是
            if (data.value == "ZBCP" || data.value == "ZZCP"){
                $("#xchpf").val("X");
                //分类类型、分类名称
                $("#klart").val("023");
                $("#classify").val("Z_PROD");
            }else if (data.value == "ZYCL"){
                $("#xchpf").val("X");
                //分类类型、分类名称
                $("#klart").val("023");
                $("#classify").val("Z_YCL");

                //物料主数据的创建，修改：当物料类型等于，ZMYP(贸易品），ZFBL（辅料与包材），ZYCL（原材料）时：BSTMI（最小批量），BSTRF（舍入值）设置为必输
                bstmiChange(true);
            }else {
                $("#xchpf").val("0");
            }
            if (data.value == "ZKGL"){
                //采购视图，这两个默认勾选上：批次管理：XCHPF ，过账到质检库存：INSMK
                $("#xchpf").val("X");
                $("#lgort").val("1099");
                $("#lgortName").val("客供料专用库");
                Public.tip("客供料不维护财务核算视图");
                //$("#businessUsageS").prop("checked",false);
                $("#businessUsageB").prop("checked",false);

                //分类类型、分类名称
                $("#klart").val("023");
                $("#classify").val("Z_YCL");
            }
            initKunnrName(data.value);
            //刀工模板具
            if ((data.value == "ZGMB")){
                $("#raube").val("");
                Public.tip("刀工模板具不维护仓库管理视图");
                $("#businessUsageS").prop("checked",false);
            }else {
                if ($("#werks").val() == "1010"){
                    Public.tip("广州市宝绅科技有限公司RFID工厂不维护仓库管理视图");
                    $("#businessUsageS").prop("checked",false);
                }else {
                    //$("#businessUsageS").prop("checked",true);
                }
                bindEvent_raube($('#werks').val(),$("#lgort").val());
            }

            //ZBZP-保障类物品视图只需要：E-采购，L-存储管理，B-财务核算
            if ((data.value == "ZBZP")){
                Public.tip("保障类物品不维护销售、生产、仓库管理视图");
                $("#businessUsageV").prop("checked",false);
                //$("#businessUsageD").prop("checked",false);
                $("#businessUsageA").prop("checked",false);
                $("#businessUsageS").prop("checked",false);
                $('input[name="isAll"]').attr("checked",false);
            }
            bindEvent_mrp(data.value)
            bindEvent_produce(data.value);
            bindEvent_warehouse(data.value);
            bindEvent_financial(data.value);
      }
    });
    //产品组默认00-通用产品组
    $("#spart").val("00");

    //重量单位默认G-克
    $("#gewei").val("G");

    //有效期间标识默认D-天
    $("#iprkz").val("D");

    //可用性检查组默认02
    $("#mtvfp").val("02");
    bindEvent_sale();
    //消耗模式
    $("#vrmod").val("2");
    //逆推消耗期间
    $("#vint1").val("999");
    //顺推消耗期间
    $("#vint2").val("999");

    //期间标识默认M;
    $("#perkz").val("M");

    //库存-过期日期 默认D
    $("#sledBbd").val("B");

    //存储分区标识
    $("#lgbkz").val("001");

    //倒冲标志 :默认0
    $("#rgekz").val("0");

    switch ($("#active").val()) {
        case '0'://待填报
          //  $("#businessUsageDiv").hide();
            hideAllBusiness(false); //隐藏但不清理值
            for (var x=0;x<$("input[name='businessUsage']").length;x++) {
               if ($("input[name='businessUsage']")[x].checked) {
                  showBusiness($("input[name='businessUsage']")[x].value);
               }
            }
            if ($("#deptCode").val() === "system") {
                $("#auditForm").show();
            } else {
                $("#buttonBox").show();
                $("#showChart").remove();
            }
            if (applyType==2){ //扩展
                $("#isAll").attr("disabled",true);
            }
            break;
        case '1'://待确认
            $("#buttonBox").show();
            $("#submit").remove();
            $("#save").remove();
            $("#back").remove();
              viewOnly();
               break;
        case '2'://已办结
            // $("#auditForm").show();
            $("#buttonBox").remove();
             UICtrl.setDisable("#basicInfoDiv");
             UICtrl.setDisable("#distributeDiv");
             UICtrl.setDisable("#mrpDiv");
             viewOnly();
            break;
      //  case '3'://已办结
          //  showRejectCauseBox();
       //     $("#buttonBox").remove();
       //     break;
        default://其他/详情
            $("#buttonBox").show();
            break;
    }

     if (isAll=="1"){
        $('input[name="isAll"]').attr("checked",true);
     }

    $('input[name="isAll"]').change(function () {
       // debugger
        if ($(this).is(':checked')) {
            $("#busiLens").val(dictUsage.length);
            coRowNum=dictUsage.length;
             for (var x=0;x<$("input[name='businessUsage']").length;x++) {
                 if (("1010" == $("#werks").val() || "ZGMB" == $("#mtart").val() ) && x == 5){
                     $("input[name='businessUsage']")[x].checked = false;
                 }else if ("ZKGL" == $("#mtart").val() && x == 6){
                     $("input[name='businessUsage']")[x].checked = false;
                 }else {
                     $("input[name='businessUsage']")[x].checked = true;
                 }
             }
            showAllBusiness();
        } else {
            $("input[name='businessUsage']").each(function(){
                $(this).attr("checked",false);
                hideAllBusiness(true);
            })
        }
    });

    var dictUsage=dictUsages.split(";");
    $('input[name="businessUsage"]').change(function () {
       //alert($(this).is(':checked'));
        if ($(this).is(':checked')) {
             //let datas=gridManager.getData();
            // var name="",deptCode="";
            coRowNum=MathUtil.add(coRowNum,1);
            showBusiness($(this).val());

            if ("S"== $(this).val() ){

                if ($("#werks").val() == "1010"){
                    Public.tip("广州市宝绅科技有限公司RFID工厂不维护仓库管理视图");
                    $("#businessUsageS").prop("checked",false);
                }else {
                    $("#businessUsageS").prop("checked",true);
                }
                if ($("#mtart").val() == "ZGMB"){
                    Public.tip("刀工模板具不维护仓库管理视图");
                }else {
                    $("#businessUsageS").prop("checked",true);
                }
                // if ($("#mtart").val() == "ZKGL"){
                //     Public.tip("客供料不维护仓库管理视图");
                // }
            }
            if ("B"== $(this).val() ){
                if ($("#mtart").val() == "ZKGL"){
                    Public.tip("客供料不维护财务核算视图");
                    $("#businessUsageB").prop("checked",false);
                }else {
                    $("#businessUsageB").prop("checked",true);
                }
            }
            if (coRowNum==dictUsage.length){
                $('input[name="isAll"]')[0].checked = true;
            }
        } else {
             hideBusiness($(this).val());
             coRowNum=MathUtil.sub(coRowNum,1);
             $('input[name="isAll"]').attr("checked",false);
        }
    });
}

function initbstmi(mtart){
    if (mtart == "ZFBL" || mtart == "ZMYP" || mtart == "ZYCL"){
        //物料主数据的创建，修改：当物料类型等于，ZMYP(贸易品），ZFBL（辅料与包材），ZYCL（原材料）时：BSTMI（最小批量），BSTRF（舍入值）设置为必输
        bstmiChange(true);
    }else {
        bstmiChange(false);
    }
}

function initKunnrName(mtart){
    if (mtart == "ZKGL"){
        UICtrl.setElRequiredFlag("#kunnrName", true);
    }else {
        UICtrl.setElRequiredFlag("#kunnrName", false);
        $("#kunnrName").val("")
        $("#kunnr").val("")
    }
}

function bstmiChange(flag){
    UICtrl.setElRequiredFlag("#bstmi", flag);
    UICtrl.setElRequiredFlag("#bstrf", flag);
}

function  showBusiness(busiCode) {
    if (busiCode=="E") { //采购
        $("#purchaseDiv").show();
        purchaseMustInput(true);
    }
}

function  hideBusiness(busiCode) {
    if (busiCode=="E") {
        $("#purchaseDiv").hide();
        purchaseMustInput(false);
        clearForm_purchase();
    }
}
function  showAllBusiness() {
    $("#purchaseDiv").show();
    purchaseMustInput(true);
}

function  hideAllBusiness(flag) {
    $("#purchaseDiv").hide();
    purchaseMustInput(false);
    if (flag) {
        clearForm_purchase();
    }
}

function  showBusinessReadOnly(busiCode) {
  if (busiCode=="E") {
      $("#purchaseDiv").show();
      UICtrl.setDisable("#purchaseDiv");
  }
}
function viewOnly(){ //只能查看
      hideAllBusiness();
    for (var x=0;x<$("input[name='businessUsage']").length;x++) {
        if ($("input[name='businessUsage']")[x].checked) {
          showBusinessReadOnly($("input[name='businessUsage']")[x].value);
        }
    }
    UICtrl.setDisable("#basicInfoDiv");
    UICtrl.setDisable("#distributeDiv");
    UICtrl.disable($("#businessUsage"));
    //$("#businessUsage").attr("disabled",true);

    $("#maktxRemZh").attr("readonly",true);
    $("#maktxRemEn").attr("readonly",true);
    $("#isAll").attr("disabled",true);
}

function purchaseMustInput(flag) { //采购必输项
    UICtrl.setElRequiredFlag("#ekgrpName",flag);
    UICtrl.setElRequiredFlag("#ekgrp",flag);
    if (!flag) {
        UICtrl.setElRequiredFlag("#umrenPurch", flag);
        UICtrl.setElRequiredFlag("#umrezPurch", flag);
    }
}

/**
 * 表单提交
 * @returns {boolean}
 */
function saveForm(status) {
   // alert($("#businessCode").val());
   // let extendedData = getExtendedData();
   // debugger
   // if (!extendedData) return false;
    var length = $('input[name="businessUsage"]:checked').length;
    if (status==1 && length <= 0){
        Public.errorTip("请选择业务用途！");
        return false;
    }
    var _self = this;
    $("#active").val(status);
    $('#submitForm').ajaxSubmit({
        url: web_app.name + '/sapNonProdApplyNext/saveSapNonProdApplyDept.ajax',
        //param: extendedData,
        success: function (data) {
            $("#applyDeptId").val(data.applyDeptId);
            if (status == 1){
                $("#matnr").val(data.matnr);
            }
             if (data.type=="S") {
               Public.successTip("保存成功！");
             } else {
               Public.tip(data.backStr);
             }
            if (status==1 && data.type=="S") {
                $("#buttonBox").remove();
            }
           // _self.close();
            UICtrl.reloadTabById('#homepage');
        }
    });
}


//撤销采购
function  clearForm_purchase(){
    // $("#saleForm").formClean();
    $("#bstme").val("");
    $("#bstmeName").val("");
    $("#umrenPurch").val("");
    $("#umrezPurch").val("");
    $("#ekgrp").val("");
    $("#ekgrpName").val("");
}

/**
 *领导确认/回退
 */
function  confirmForm(val){
    $("#status").val(val);
    if (control.isConfirm) {
        Public.successTip("已确认！");
        return false;
    }
  //  let extendedData = getExtendedData();
  //  if (!extendedData) return false;
    $('#submitForm').ajaxSubmit({
        url: web_app.name + '/sapNonProdApplyNext/confirmSapNonProdApplyDept.ajax?confirm='+val,
       // param: extendedData,
        success: function (data) {
          //  alert(data.result);
            if (data.result=='')  {
                Public.successTip("操作成功！");
            } else {
                Public.errorTip(data.result);
            }
            //parent.reloadSpecialTaskGrid();
           // parent.homepage.trackTaskContent
            UICtrl.reloadTabById('homepage');
            $("#buttonBox").remove();
            control.isConfirm = true;
           // _self.close();
        }
    });

}

function bindEvent() {
    //物料组
    $('#matklTypeName').searchbox({
        type: "system", name: "matklDictionary",
        getParam: function (item) {
            return {
                fieldName: "MATKLTYPE",
                filterValue: $("#mtart").val()
            }
        },
        onChange: function (value, data) {
            $('#matklType').val(data.MATKL);
            $('#matklTypeName').val(data.WGBEZ);
        }
    });
    $('#matklName').searchbox({
        type: "system", name: "matklDictionary",
        getParam: function (item) {
            return {
                fieldName: "MATKL",
                filterValue: $("#matklType").val()
            }
        },
        onChange: function (value, data) {
            $('#matkl').val(data.MATKL);
            $('#matklName').val(data.WGBEZ);


            // 920	后勤用品	6001
            //当选择物料类型为ZBZP-保障类物品时，需根据不同的物料组对字段：评估类（BKLAS）进行赋值
            if ("ZBZP" == $("#mtart").val()){
                setBklasByMatklAndMtart(data.MATKL,$("#mtart").val());
            }
        }
    });

    $('#kunnrName').searchbox({
        type: "system", name: "dictionary",
        getParam: function (item) {
            return {fieldName: "KUNNR"}
        },
        onChange: function (value, data) {
            $('#kunnr').val(data.KUNNR);
            $('#kunnrName').val(data.NAME);
        }
    });

    //基本计量单位
    $('#meinsName').searchbox({
        type: "system", name: "dictionary",
        getParam: function (item) {
            return {fieldName: "MEINS"}
        },
        onChange: function (value, data) {
            $('#meins').val(data.MSEH3);
            $('#meinsName').val(data.MSEHL);

            if ($('#bstme').val()==data.MSEH3) { //采购计量单位
                $('#bstme').val("");
                $('#bstmeName').val("");
                UICtrl.setElRequiredFlag("#umrenPurch", false);
                UICtrl.setElRequiredFlag("#umrezPurch", false);
            }
        }
    });


    //工厂
    $('#werksName').searchbox({
        type: "system", name: "dictionary",
        getParam: function (item) {
            return {fieldName: "WERKS"}
        },
        onChange: function (value, data) {
            $('#werks').val(data.WERKS);
            $('#werksName').val(data.NAME1);
            //选了工厂和库存地点，带出仓库
            if (data.WERKS == "1000" && $('#lgort').val() != "1004"){
                $("#lgnum").val("W00");
                $("#lgnumName").val("广州宝绅印刷工厂仓库");
            }
            if (data.WERKS == "1010"){
                Public.tip("广州市宝绅科技有限公司RFID工厂不维护仓库管理视图");
                $("#businessUsageS").prop("checked",false);
            }else {
                var mtart = $("#mtart").val();
                if (mtart == "ZGMB" ){
                    Public.tip("刀工模板具不维护仓库管理视图");
                    $("#businessUsageS").prop("checked",false);
                }
            }

            // var mtart = $("#mtart").val();
            // if (mtart == "ZGMB" ){
            //     Public.tip("刀工模板具不维护仓库管理视图");
            //     $("#businessUsageS").prop("checked",false);
            // }else if (mtart == "ZKGL"){
            //     Public.tip("客供料不维护财务核算视图");
            //     //$("#businessUsageS").prop("checked",false);
            //     $("#businessUsageB").prop("checked",false);
            // } else {
            //     //选择了工厂和库存地点后，带出存储条件
            //     bindEvent_raube(data.WERKS,$('#lgort').val());
            //     if (data.WERKS == "1010" && $("input[name='businessUsage']")[5].checked){
            //         Public.tip("广州市宝绅科技有限公司RFID工厂不维护仓库管理视图");
            //         $("#businessUsageS").prop("checked",false);
            //     }else {
            //         $("#businessUsageS").prop("checked",true);
            //     }
            // }
            //选择了工厂和库存地点后，带出存储条件
            bindEvent_raube(data.WERKS,$('#lgort').val());
            //选择了工厂、库存地点、仓库号，带出存储类型和上下架存储类型
            bindEvent_lgtyp(data.WERKS,$('#lgort').val(),$('#lgnum').val());

            //库存-利润中心
            if (data.WERKS == "1000"){
                $("#prctr").val("10001000");
            }else if (data.WERKS == "1010"){
                $("#prctr").val("10001001");
            }
        }
    });
    //库存地点
    $('#lgortName').searchbox({
        type: "system", name: "dictionary",
        getParam: function (item) {
            return {fieldName: "LGORT", filterValue: $('#werks').val()}
        },
        onChange: function (value, data) {
            $('#lgort').val(data.LGORT);
            $('#lgortName').val(data.LGOBE);

            $('#lgortProfit').val(data.LGORT);
            $('#lgortProfitName').val(data.LGOBE);

            $('#lgortQm').val(data.LGORT);
            $('#lgortQmName').val(data.LGOBE);

            if ($('#werks').val() == "1000" && data.LGORT != "1004"){
                $("#lgnum").val("W00");
                $("#lgnumName").val("广州宝绅印刷工厂仓库");
            }

            var mtart = $("#mtart").val();
            if (mtart != "ZGMB" ){
                //选择了工厂和库存地点后，带出存储条件
                bindEvent_raube($('#werks').val(),data.LGORT);
            }

            //选择了工厂、库存地点、仓库号，带出存储类型和上下架存储类型
            bindEvent_lgtyp($('#werks').val(),data.LGORT,$('#lgnum').val());
            bindEvent_mrp(mtart)

            $("#lgpro").val(data.LGORT);
            $("#lgproName").val(data.LGOBE);
        }
    });


     //默认采购组 --采购视图
    $('#ekgrpName').searchbox({
        type: "system", name: "dictionary",
        getParam: function (item) {
            return {fieldName: "EKGRP"}
        },
        onChange: function (value, data) {
            $('#ekgrp').val(data.EKGRP);
            $('#ekgrpName').val(data.EKNAM);
        }
    });
    //采购计量单位
    $('#bstmeName').searchbox({
        type: "system", name: "dictionary",
        getParam: function (item) {
            return {fieldName: "MEINS"}
        },
        onChange: function (value, data) {
           if ($('#meins').val()==data.MSEH3) {
               Public.errorTip("不能与基本计量单位相同！");
               $('#bstme').val("");
               $('#bstmeName').val("");
               UICtrl.setElRequiredFlag("#umrenPurch",false);
               UICtrl.setElRequiredFlag("#umrezPurch",false);
           } else {
             $('#bstme').val(data.MSEH3);
             $('#bstmeName').val(data.MSEHL);
               UICtrl.setElRequiredFlag("#umrenPurch",true);
               UICtrl.setElRequiredFlag("#umrezPurch",true);
          }
        }
    });

    //参考物料选择
    $("#copyMatnr").searchbox({
        type: "material", name: "selectMaterials",
        getParam: function (item) {
            if (Public.isBlank($('#mtart').val())){
                Public.tip("请先选择物品类型！")
                return false
            }
            if (Public.isBlank($('#matkl').val())){
                Public.tip("请先选择物料组！")
                return false
            }
            return {
                mtart: $("#mtart").val(),
                matkl: $("#matkl").val()
            }
        },
        onChange: function (value, data) {
            //先清空勾选视图
            $("input[name='businessUsage']").each(function(){
                $(this).prop("checked",false);
                hideAllBusiness(true);
            })

            $("#copyMatnr").val(value.text);
            var mtart = $("#mtart").val();
            var matkl = $("#matkl").val();
            if (Public.isBlank(mtart)){
                $("#mtart").val(data.mtart)
                $("#mtart_text").val(data.mtartTextView)
            }
            if (Public.isBlank(matkl)){
                $("#matkl").val(data.matkl)
                $("#matklName").val(data.matklName)
            }
            $("#groes").val(data.groes)
            $("#spartName").val(data.spartName)
            $("#spart").val(data.spart)
            $("#mtposMara").val(data.mtposMara)
            //$("#maktx").val(data.maktx)
            $("#xchpf").val(data.xchpf)
            $("#maktxEn").val(data.maktxEn)
            //$("#meinsName").val(data.meinsName)
            //$("#meins").val(data.meins)
            $("#werksName").val(data.werksName)
            $("#werks").val(data.werks)
            $("#lgortName").val(data.lgortName)
            $("#lgort").val(data.lgort)
            $("#raube").val(data.raube)
            $("#brgew").val(data.brgew)
            $("#gewei").val(data.gewei)
            $("#volum").val(data.volum)
            $("#voleh").val(data.voleh)
            $("#iprkz").val(data.iprkz)
            $("#mhdhb").val(data.mhdhb)
            $("#mhdrz").val(data.mhdrz)
            $("#length").val(data.length)
            $("#widthCm").val(data.widthCm)
            $("#thickness").val(data.thickness)
            $("#weight").val(data.weight)
            $("#singleThickness").val(data.singleThickness)
            $("#klart").val(data.klart)
            $("#classify").val(data.class)

            //$("#businessUsage").val(data.businessUsage)
            var businessUsages = data.businessUsage;
            var businessUsageStr = businessUsages.split(",");
            for (let i = 0; i < businessUsageStr.length; i++) {
                var businessUsageVal = businessUsageStr[i];
                var id = "businessUsage"+businessUsageVal;
                $("#"+id).prop("checked",true);
                coRowNum=MathUtil.add(coRowNum,1);
                showBusiness(businessUsageVal)
            }
            $("#isAll").val(data.isAll)

            $("#lgtypName").val(data.lgtypName)
            $("#lgtyp").val(data.lgtyp)
            $("#mtvfp").val(data.mtvfp)

            //销售视图
            $("#vkorgName").val(data.vkorgName)
            $("#vkorg").val(data.vkorg)
            $("#vtwegName").val(data.vtwegName)
            $("#vtweg").val(data.vtweg)
            $("#alandName").val(data.alandName)
            $("#aland").val(data.aland)
            $("#taxkm").val(data.taxkm)
            $("#mtpos").val(data.mtpos)
            $("#tragr").val(data.tragr)
            $("#ladgr").val(data.ladgr)
            $("#ladgrName").val(data.ladgrName)

            //采购视图
            $("#bstmeName").val(data.bstmeName)
            $("#bstme").val(data.bstme)
            $("#umrenPurch").val(data.umrenPurch)
            $("#umrezPurch").val(data.umrezPurch)
            $("#ekgrpName").val(data.ekgrpName)
            $("#ekgrp").val(data.ekgrp)

            //MRP视图
            $("#rgekz").val(data.rgekz)
            $("#strgr").val(data.strgr)
            $("#sbdkz").val(data.sbdkz)
            $("#vrmod").val(data.vrmod)
            $("#vint1").val(data.vint1)
            $("#vint2").val(data.vint2)
            $("#perkz").val(data.perkz)
            $("#dismm").val(data.dismm)
            $("#dispo").val(data.dispo)
            $("#disls").val(data.disls)
            $("#bstmi").val(data.bstmi)
            $("#bstrf").val(data.bstrf)
            $("#lgproName").val(data.lgproName)
            $("#lgpro").val(data.lgpro)
            $("#lgfsbName").val(data.lgfsbName)
            $("#lgfsb").val(data.lgfsb)

            //生产视图
            $("#fevor").val(data.fevor)
            $("#sfcpf").val(data.sfcpf)

            //存储视图
            $("#lgortQmName").val(data.lgortQmName)
            $("#lgortQm").val(data.lgortQm)
            $("#sernp").val(data.sernp)
            $("#serlv").val(data.serlv)
            $("#prctr").val(data.prctr)
            $("#insmk").val(data.insmk)
            $("#sledBbd").val(data.sledBbd)

            //仓库视图
            $("#lgnumName").val(data.lgnumName)
            $("#lgnum").val(data.lgnum)
            $("#lgortProfitName").val(data.lgortProfitName)
            $("#lgortProfit").val(data.lgortProfit)
            $("#ltkzaName").val(data.ltkzaName)
            $("#ltkza").val(data.ltkza)
            $("#lety1").val(data.lety1)
            $("#lhmg1").val(data.lhmg1)
            $("#lhme1Name").val(data.lhme1Name)
            $("#lhme1").val(data.lhme1)
            $("#ltkzeName").val(data.ltkzeName)
            $("#ltkze").val(data.ltkze)
            $("#lgbkz").val(data.lgbkz)

            //财务视图
            $("#bklas").val(data.bklas)
            $("#vprsv").val(data.vprsv)
            $("#mlast").val(data.mlast)
            $("#peinh").val(data.peinh)
            $("#ncost").val(data.ncost)
            $("#hkmat").val(data.hkmat)
            $("#verpr").val(data.verpr)
            $("#stprs").val(data.stprs)
            $("#ekalr").val(data.ekalr)
            $("#awsls").val(data.awsls)
            $("#eklas").val(data.eklas)
        }
    });

    //正面图片
    var _img=$('#showFrontPicture');
    var _frontPicturePath=$('#frontPicturePath').val();
    if (Public.isNotBlank(_frontPicturePath)) {
        _img[0].src = $.getCSRFUrl('attachment/downFileBySavePath.ajax',{file:_frontPicturePath});
    }
    $('#addFrontPicture').uploadButton({
        filetype: ['jpg','gif','jpeg','png','bmp'],
        afterUpload: function(data){
            _img[0].src = $.getCSRFUrl('attachmentDownFile.ajax',{id:data.id});
        },
        param: function(){
            return {bizCode: 'frontPicture', bizId: $("#id").val(), flag: 'false', deleteOld: 'true', returnPath: 'true'};
        }
    });

    //反面图片
    var back_img=$('#showBackPicture');
    var _backPicturePath=$('#backPicturePath').val();
    if (Public.isNotBlank(_backPicturePath)) {
        back_img[0].src = $.getCSRFUrl('attachment/downFileBySavePath.ajax',{file:_backPicturePath});
    }
    $('#addBackPicture').uploadButton({
        filetype: ['jpg','gif','jpeg','png','bmp'],
        afterUpload: function(data){
            back_img[0].src = $.getCSRFUrl('attachmentDownFile.ajax',{id:data.id});
        },
        param: function(){
            return {bizCode: 'backPicture', bizId: $("#id").val(), flag: 'false', deleteOld: 'true', returnPath: 'true'};
        }
    });

    $("#maktx").click(function () {
        if ($('#maktx').prop('readonly')) {
            return;
        }
        UICtrl.showAjaxDialog({
            title: '汉语品名维护',
            width: 700,
            height: 400,
            url: web_app.name + '/sapNonProdApply/showMaterialNameElement.load',
            param:{billCode:$("#submitForm #billCode").val()},
            init: function (){

            },
            ok: function () {
                var result = $("#materialNameElement #maktx").val();
                var specifications = $("#materialNameElement #specifications").val();
                var thickness = $("#materialNameElement #thickness").val();
                var weight = $("#materialNameElement #weight").val();
                var maktxRemZh = $("#materialNameElement #maktxRemZh").val();
                $('#materialNameElement').ajaxSubmit({
                    url: web_app.name + '/sapNonProdApply/saveMaterialNameElement.ajax',
                    param: "",
                    success: function (data) {
                        $("#maktx").val(result);
                        $("#groes").val(specifications);
                        $("#thickness").val(thickness);
                        $("#weight").val(weight);
                        $("#maktxRemZh").val(maktxRemZh);
                    }
                });
                this.close();
            }
        })
    })
}

function bindEvent_raube(werks,lgort){
    switch (werks) {
        case '1000':
            switch (lgort) {
                case '1001':
                    $("#raube").val("R1");
                    break;
                case '1002':
                    $("#raube").val("R2");
                    break;
                case '1003':
                    $("#raube").val("R3");
                    break;
                case '1004':
                    $("#raube").val("R4");
                    break;
                case '1005':
                    $("#raube").val("R5");
                    break;
                case '1006':
                    $("#raube").val("R6");
                    break;
                case '2000':
                    $("#raube").val("H1");
                    break;
                case '2001':
                    $("#raube").val("H2");
                    break;
                case '8001':
                    $("#raube").val("Z1");
                    break;
                case '8002':
                    $("#raube").val("Z2");
                    break;
                case '8003':
                    $("#raube").val("Z3");
                    break;
                case '8005':
                    $("#raube").val("Z5");
                    break;
                case '8006':
                    $("#raube").val("Z6");
                    break;
                case '8100':
                    $("#raube").val("Z7");
                    break;
                default:
                    $("#raube").val("");
                    break;
            }
            break;
        case '1010':
            switch (lgort) {
                case '1001':
                    $("#raube").val("Y1");
                    break;
                case '1002':
                    $("#raube").val("Y2");
                    break;
                case '2000':
                    $("#raube").val("Y3");
                    break;
                case '8000':
                    $("#raube").val("Y5");
                    break;
                case '8100':
                    $("#raube").val("Y6");
                    break;
                default:
                    $("#raube").val("");
                    break;
            }
            break;
    }
}

//绑定仓库与存储类型；根据工厂，库存地点，仓库号来确定仓储类型、上下架存储类型
function bindEvent_lgtyp(werks,lgort,lgnum) {
    if (werks == "1000" && lgnum == "W00"){
        if (lgort == "1001"){
            $("#lgtyp").val("001");
            $("#ltkze").val("001");
            $("#ltkza").val("001");
            $("#lgtypName").val("原料一库存储区");
            $("#ltkzeName").val("原料一库存储区");
            $("#ltkzaName").val("原料一库存储区");
        }else if (lgort == "1002"){
            $("#lgtyp").val("002");
            $("#ltkze").val("002");
            $("#ltkza").val("002");
            $("#lgtypName").val("原料二库存储区");
            $("#ltkzeName").val("原料二库存储区");
            $("#ltkzaName").val("原料二库存储区");
        }else if (lgort == "1003"){
            $("#lgtyp").val("003");
            $("#ltkze").val("003");
            $("#ltkza").val("003");
            $("#lgtypName").val("原料三库存储区");
            $("#ltkzeName").val("原料三库存储区");
            $("#ltkzaName").val("原料三库存储区");
        }else if (lgort == "1005"){
            $("#lgtyp").val("004");
            $("#ltkze").val("004");
            $("#ltkza").val("004");
            $("#lgtypName").val("辅料库存储区");
            $("#ltkzeName").val("辅料库存储区");
            $("#ltkzaName").val("辅料库存储区");
        }else if (lgort == "1006"){
            $("#lgtyp").val("005");
            $("#ltkze").val("005");
            $("#ltkza").val("005");
            $("#lgtypName").val("油墨库/危化品库存储区");
            $("#ltkzeName").val("油墨库/危化品库存储区");
            $("#ltkzaName").val("油墨库/危化品库存储区");
        }else if (lgort == "2000"){
            $("#lgtyp").val("006");
            $("#ltkze").val("006");
            $("#ltkza").val("006");
            $("#lgtypName").val("自制半成品库存储区");
            $("#ltkzeName").val("自制半成品库存储区");
            $("#ltkzaName").val("自制半成品库存储区");
        }else if (lgort == "2001"){
            $("#lgtyp").val("007");
            $("#ltkze").val("007");
            $("#ltkza").val("007");
            $("#lgtypName").val("委外半成品库存储区");
            $("#ltkzeName").val("委外半成品库存储区");
            $("#ltkzaName").val("委外半成品库存储区");
        }else if (lgort == "8001"){
            $("#lgtyp").val("008");
            $("#ltkze").val("008");
            $("#ltkza").val("008");
            $("#lgtypName").val("成品一库存储区");
            $("#ltkzeName").val("成品一库存储区");
            $("#ltkzaName").val("成品一库存储区");
        }else if (lgort == "8002"){
            $("#lgtyp").val("009");
            $("#ltkze").val("009");
            $("#ltkza").val("009");
            $("#lgtypName").val("成品二库存储区");
            $("#ltkzeName").val("成品二库存储区");
            $("#ltkzaName").val("成品二库存储区");
        }else if (lgort == "8003"){
            $("#lgtyp").val("010");
            $("#ltkze").val("010");
            $("#ltkza").val("010");
            $("#lgtypName").val("成品三库存储区");
            $("#ltkzeName").val("成品三库存储区");
            $("#ltkzaName").val("成品三库存储区");
        }else if (lgort == "8005"){
            $("#lgtyp").val("011");
            $("#ltkze").val("011");
            $("#ltkza").val("011");
            $("#lgtypName").val("成品五库存储区");
            $("#ltkzeName").val("成品五库存储区");
            $("#ltkzaName").val("成品五库存储区");
        }else if (lgort == "8006"){
            $("#lgtyp").val("012");
            $("#ltkze").val("012");
            $("#ltkza").val("012");
            $("#lgtypName").val("油墨库/危化品库存储区");
            $("#ltkzeName").val("油墨库/危化品库存储区");
            $("#ltkzaName").val("油墨库/危化品库存储区");
        }else if (lgort == "8100"){
            $("#lgtyp").val("013");
            $("#ltkze").val("013");
            $("#ltkza").val("013");
            $("#lgtypName").val("包装材料库存储区");
            $("#ltkzeName").val("包装材料库存储区");
            $("#ltkzaName").val("包装材料库存储区");
        }else if (lgort == "1099"){
            $("#lgtyp").val("014");
            $("#ltkze").val("014");
            $("#ltkza").val("014");
            $("#lgtypName").val("客供料专用库存储区");
            $("#ltkzeName").val("客供料专用库存储区");
            $("#ltkzaName").val("客供料专用库存储区");
        }
    }
}

function bindEvent_sale() {
    //销售组织默认1000
    $("#vkorg").val("1000");
    $("#vkorgName").val("广州宝绅科技销售组织");

    //销售渠道默认00
    $("#vtweg").val("00");
    $("#vtwegName").val("广州宝绅科技销售组织");

    //税收发运国CN
    $("#aland").val("CN");
    $("#alandName").val("中国");

    //税分类默认1
    $("#taxkm").val("1");

    //销售项次组默认NORM
    $("#mtpos").val("NORM");
    //运输组0001
    $("#tragr").val("0001");
    //装载组0001
    $("#ladgr").val("0001");
    $("#ladgrName").val("吊车");
}

function bindEvent_mrp(mtart){
    if (mtart == "ZFBL" || mtart == "ZMYP" || mtart == "ZSHB" || mtart == "ZYCL"){
        $("#dismm").val("PD");
        $("#dispo").val("101");//MRP控制者
        $("#disls").val("EX");//批量规模
        $("#strgr").val("70");//策略组
        $("#beskz").val("F");//获取类型
    }else if (mtart == "ZBPJ"){
        $("#dismm").val("PD");
        $("#dispo").val("104");//MRP控制者
        $("#disls").val("EX");//批量规模
        $("#strgr").val("70");//策略组
        $("#beskz").val("F");//获取类型
    } else if (mtart == "ZBZP" || mtart == "ZCOM" || mtart == "ZECC"
        || mtart == "ZGMB"  ){
        $("#dismm").val("ND");
        $("#beskz").val("F");//获取类型
    } else if (mtart == "ZSRV" || mtart == "ZXHP" || mtart == "ZXNJ"){
        $("#dismm").val("ND");
    }else if (mtart == "ZKGL"){
        $("#dismm").val("ND");
        $("#beskz").val("");//获取类型

        //物料主数据的创建，修改 物料类型为：ZGKL（客供料），字段mrp控制者（DISPO），改为默认并且只能是105
        $("#dismm").val("PD");
        $("#disls").val("EX");//批量规模
        $("#strgr").val("40");//策略组
        $("#dispo").val("105");//MRP控制者
    }

    if (mtart != "ZSHB"){
        $("#sbdkz").val("2");
    }

    //采购收货默认库存地
    if (mtart == "ZYCL" || mtart == "ZMYP" || mtart == "ZFBL"){
        $("#lgfsb").val("Q000");
        $("#lgfsbName").val("质检库/不良品库");
    }else if (mtart == "ZBPJ" || mtart == "ZBZP" || mtart == "ZCOM"
        || mtart == "ZECC" || mtart == "ZGMB" || mtart == "ZKGL" || mtart == "ZSHB"){
        $("#lgfsb").val($("#lgort").val());
        $("#lgfsbName").val($("#lgortName").val());
    }

    //生产发货默认库存地
    if (mtart != "ZSRV" && mtart != "ZXHP" && mtart != "ZXNJ"){
        $("#lgpro").val($("#lgort").val());
        $("#lgproName").val($("#lgortName").val());
    }
}

function bindEvent_produce(mtart) {
    // if (mtart == "ZSHB"){
    //     $("#fevor").val("001");
    //     $("#sfcpf").val("Z00001");
    // }
    $("#fevor").val("001");
    $("#sfcpf").val("Z00001");
}

function bindEvent_warehouse(mtart){
    //序列号参数、序列号水平
    if (mtart == "ZGMB"){
        $("#sernp").val("Z005");
        $("#serlv").val("1");
    }else {
        $("#sernp").val("");
        $("#serlv").val("");
    }

    //过账到质检
    if (mtart == "ZFBL" || mtart == "ZMYP" || mtart == "ZYCL" || mtart == "ZKGL"){
        //过账到质检库存：INSMK
        $("#insmk").val("X");
    }else {
        $("#insmk").val("0");
    }
}

function bindEvent_financial(mtart) {
    if (mtart == "ZBPJ" || mtart == "ZCOM" || mtart == "ZECC"
        || mtart == "ZFBL" || mtart == "ZGMB" ){
        $("#bklas").val("3001");//评估分类
        $("#eklas").val("3001");//销售评估分类

    }else if ( mtart == "ZMYP" ){
        $("#bklas").val("7930");//评估分类
        $("#eklas").val("7930");//销售评估分类
    } else if ( mtart == "ZSHB"){
        $("#bklas").val("7920");//评估分类
        $("#eklas").val("7920");//销售评估分类
        $("#awsls").val("PP1");//差异码

    }else if (mtart == "ZKGL" || mtart == "ZXHP" || mtart == "ZXNJ"){
        $("#bklas").val("");//评估分类
        $("#eklas").val("");//销售评估分类

    }else if (mtart == "ZSRV"){
        $("#bklas").val("7940");//评估分类
        $("#eklas").val("7940");//销售评估分类

    }else if (mtart == "ZYCL"){
        $("#bklas").val("3000");//评估分类
        $("#eklas").val("3000");//销售评估分类
    }else if (mtart == "ZBZP"){
        setBklasByMatklAndMtart($("#matkl").val(),mtart)
    }

    if (mtart == "ZKGL" || mtart == "ZXHP" || mtart == "ZXNJ"){
        $("#peinh").val("");//定价基数
        $("#hkmat").val("0");//物料来源
        $("#ekalr").val("0");//数量结构
    }else {
        $("#mlast").val("2");//价格确定
        $("#vprsv").val("V");//价格控制
        $("#peinh").val("1");//定价基数
        $("#hkmat").val("X");//物料来源
        $("#ekalr").val("X");//数量结构
    }
    //物料类型=ZSRV服务时。成本视图——不计算成本默认打勾选上
    // 物料类型	字段NCOST
    // ZBPJ	空
    // ZBZP	空
    // ZCOM	空
    // ZECC	空
    // ZGMB	空
    // ZKGL	X
    // ZSHB	空
    // ZSRV	见注解
    // ZXNJ	X
    // ZYCL	空
    // ZZCP	空
    if (mtart == "ZKGL" || mtart == "ZXNJ"){
        $("#ncost").val("X");//不参与成本核算
        $("#ncost_text").val("X-是");//不参与成本核算
    }else if (mtart == "ZSRV"){
        $("#ncost").val("");//不参与成本核算
        $("#ncost_text").val("");//不参与成本核算
    }else {
        $("#ncost").val("0");//不参与成本核算
        $("#ncost_text").val("0-否");//不参与成本核算
    }
    //调整为全部传空
    //$("#ncost").val("0");//不参与成本核算

}


function getExtendedData() {
    let msg = "[";
    let isUndefined = false;
    let extendedData = {};
        let deptStaffResult = gridManager.getData();
        for (var i = 0; i < deptStaffResult.length; i++) {
            //  alert(deptStaffResult[i].deptName); alert(deptStaffResult[i].userCode);
            if (deptStaffResult[i].userCode == undefined) {
                //if (isUndefined) {
                isUndefined = true;
                break;
            }
        }
        if (isUndefined) {
            Public.tip(deptStaffResult[i].deptName + '未选择对应分发人员');
            return false
        }
        extendedData.deptStaff = Public.encodeJSONURI(deptStaffResult);
      return extendedData;
}


function rejectForm() {
    $('#auditForm').ajaxSubmit({
        url: web_app.name + '/sapNonProdApplyNext/rejectNonProdApplyDept.ajax',
        param: {meId:getMeId()},
        success: function (data) {
            Public.successTip("已驳回！");
            _self.close();
        }
    });

}

function checkThrough(){
    $('#exPass').ajaxSubmit({
        url: web_app.name + '/sapNonProdApplyNext/rejectNonProdApplyDept.ajax',
        param: {meId:getMeId()},
        success: function (data) {
            Public.successTip("检查通过！");
            _self.close();
        }
    });
}


/**
 * 根据选择的驳回的部门生成输入框
 */
function loadRejectReasonBox() {
    $('input[name="auditDept"]').change(function () {
            let val = $(this).val()
            let textData = $(this).parent().text().trim()
            if (this.checked) {
                if ($(`#id_${val}`).length) {
                    // 元素存在
                    $(`#id_${val}`).show();
                } else {
                    // 元素不存在
                    let box = `<div id="id_${val}">
                            <div class="col-xs-4 col-sm-2" style="height:60px;">
                                <label class="hg-form-label" name="${val}" title="[${textData}]驳回原因">[${textData}]驳回原因&nbsp;:</label>
                             </div>
                             <div class="col-xs-8 col-sm-10 col-warp col-white-bg" style="height:60px;">
                                <textarea name="${val}"  label="[${textData}]驳回原因" id="text_${val}"></textarea>
                             </div>
                        </div>`;
                    $("#rejectReasonBox").append(box)
                }
                $(window).scrollTop($(document).height());
            } else {
                $(`#id_${val}`).hide();
            }
        }
    );
}

function getMeId() {
    return $("#meId").val() || '';
}

function setBklasByMatklAndMtart(value,mtart){
    if ("ZBZP" == mtart){
        if (value == "900"){// 900	办公文具	6000
            $("#bklas").val("6000");
        }else if (value == "92001"){// 92001	建材类 	6002
            $("#bklas").val("6002");
        }else if (value == "92002"){// 92002	劳保用品	6003
            $("#bklas").val("6003");
        }else if (value == "92003"){// 92003	清洁用品	6005
            $("#bklas").val("6005");
        }else if (value == "92004"){// 92004	食品调料	6006
            $("#bklas").val("6006");
        }else if (value == "92005"){// 92005	五金备件	6007
            $("#bklas").val("6007");
        }else if (value == "92006"){// 92006	市场公关品 	6008
            $("#bklas").val("6008");
        }else if (value == "92007"){// 92007	餐厨用具	6009
            $("#bklas").val("6009");
        }else if (value == "92008"){// 92008	广告宣传品 	6010
            $("#bklas").val("6010");
        }else if (value == "92009"){// 92009	员工福利用品	6011
            $("#bklas").val("6011");
        }
    }
}